


<h1><a name="vim" id="vim">Vim</a></h1>
<div class="level1">

<p>

<a href="http://en.wikipedia.org/wiki/Vim" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/Vim">Vim</a> is an wonderful editor. You have to spent some time to get used to this, but since then you will gain much more in produtivity.
</p>

<p>
See also <a href="http://www.inf.ufrgs.br/~kssilveira/vim_quick_reference.html" class="urlextern" title="http://www.inf.ufrgs.br/~kssilveira/vim_quick_reference.html"  rel="nofollow">Vim Quick Reference</a> <br/>

</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Vim" [1-258] -->
<h2><a name="how_to_change_vim_configuration" id="how_to_change_vim_configuration">How to change vim configuration</a></h2>
<div class="level2">

<p>

The file ~/.vimrc is read and executed every time you open vim. So if you want that a configuration change (like set number) to be true the next time you open vim, you must append it to the ~/.vimrc. Here is an example code: 
</p>
<pre class="code bash"><span class="co0"># append to ~/.vimrc</span>
$ <span class="kw3">echo</span> <span class="st_h">'set number'</span> <span class="sy0">&gt;&gt;</span> ~<span class="sy0">/</span>.vimrc</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to change vim configuration" [259-604] -->
<h2><a name="useful_vim_configurations" id="useful_vim_configurations">Useful Vim Configurations</a></h2>
<div class="level2">

<p>

Download my <a href="http://www.inf.ufrgs.br/~kssilveira/.vimrc" class="urlextern" title="http://www.inf.ufrgs.br/~kssilveira/.vimrc"  rel="nofollow">.vimrc</a> file and do the following:
</p>
<pre class="code bash"><span class="co0"># append to ~/.vimrc</span>
$ <span class="kw3">echo</span> <span class="st_h">':source path/to/my/vimrc/file/on/your/pc'</span> <span class="sy0">&gt;&gt;</span> ~<span class="sy0">/</span>.vimrc</pre>

<p>
This loads my .vimrc file everytime you open Vim.
</p>

<p>
These are the extra configurations I use:
</p>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=vim:vim&amp;codeblock=2" title="Download Snippet" class="mediafile mf_vimrc">.vimrc</a></dt>
<dd><pre class="code file vim"><span class="co1">&quot; show line numbers</span>
set number 
<span class="co1">&quot; incremental search</span>
set incsearch
<span class="co1">&quot; auto indentation</span>
set autoindent
<span class="co1">&quot; tab size</span>
set tabstop=<span class="nu0">2</span>
<span class="co1">&quot; indentation size (used on auto indentation)</span>
set shiftwidth=<span class="nu0">2</span>
<span class="co1">&quot; smart indentation (indent beginning of blocks (e.g. '{') and unnindent ending of blocks (e.g. '}'))</span>
set smartindent
<span class="co1">&quot; save with Ctrl+S</span>
	<span class="kw3">map</span><span class="sy0">!</span> <span class="sy0">&lt;</span>C<span class="sy0">-</span>s<span class="sy0">&gt;</span> <span class="sy0">&lt;</span>Esc<span class="sy0">&gt;:</span>w<span class="sy0">&lt;</span>CR<span class="sy0">&gt;</span>
	<span class="kw3">map</span>  <span class="sy0">&lt;</span>C<span class="sy0">-</span>s<span class="sy0">&gt;</span> <span class="sy0">&lt;</span>Esc<span class="sy0">&gt;:</span>w<span class="sy0">&lt;</span>CR<span class="sy0">&gt;</span>
<span class="co1">&quot; call make with F9</span>
	<span class="kw3">map</span><span class="sy0">!</span> <span class="sy0">&lt;</span>F9<span class="sy0">&gt;</span> <span class="sy0">&lt;</span>Esc<span class="sy0">&gt;:</span>make<span class="sy0">&lt;</span>CR<span class="sy0">&gt;&lt;</span>CR<span class="sy0">&gt;</span>
	<span class="kw3">map</span>  <span class="sy0">&lt;</span>F9<span class="sy0">&gt;</span> <span class="sy0">&lt;</span>Esc<span class="sy0">&gt;:</span>make<span class="sy0">&lt;</span>CR<span class="sy0">&gt;&lt;</span>CR<span class="sy0">&gt;</span>
<span class="co1">&quot; auto save files</span>
set autowrite
set autowriteall
<span class="co1">&quot; abreviations</span>
	iab #i #include
	iab #d #define
<span class="co1">&quot; reload file automatically when it changes</span>
set autoread
<span class="co1">&quot; call make -B with F8</span>
	<span class="kw3">map</span><span class="sy0">!</span> <span class="sy0">&lt;</span>F8<span class="sy0">&gt;</span> <span class="sy0">&lt;</span>Esc<span class="sy0">&gt;:</span>make <span class="sy0">-</span>B<span class="sy0">&lt;</span>CR<span class="sy0">&gt;&lt;</span>CR<span class="sy0">&gt;</span>
	<span class="kw3">map</span>  <span class="sy0">&lt;</span>F8<span class="sy0">&gt;</span> <span class="sy0">&lt;</span>Esc<span class="sy0">&gt;:</span>make <span class="sy0">-</span>B<span class="sy0">&lt;</span>CR<span class="sy0">&gt;&lt;</span>CR<span class="sy0">&gt;</span></pre>
</dd></dl>

<p>
If the save with Ctrl+S isn&#039;t working, maybe you have to change your bash configuration (see <a href="/~kssilveira/site/doku.php?id=main:bash" class="wikilink1" title="main:bash">Bash</a>).
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Useful Vim Configurations" [605-1769] -->
<h2><a name="commands" id="commands">Commands</a></h2>
<div class="level2">

<p>

<a href="/~kssilveira/site/doku.php?id=vim:commands" class="wikilink1" title="vim:commands">Vim Commands</a>
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Commands" [1770-1823] -->
<h2><a name="edit-compile-execute_cycle" id="edit-compile-execute_cycle">Edit-Compile-Execute Cycle</a></h2>
<div class="level2">
<table class="inline">
	<tr class="row0">
		<th class="col0 leftalign" colspan="2"> Session  </th>
	</tr>
	<tr class="row1">
		<td class="col0"> :mks(ession) </td><td class="col1"> create a session file </td>
	</tr>
	<tr class="row2">
		<td class="col0"> vim -S </td><td class="col1"> load a session file </td>
	</tr>
	<tr class="row3">
		<th class="col0 leftalign" colspan="2"> Make  </th>
	</tr>
	<tr class="row4">
		<td class="col0"> :mak(e) </td><td class="col1"> run make </td>
	</tr>
	<tr class="row5">
		<td class="col0"> :cl(ist) </td><td class="col1"> show make output </td>
	</tr>
	<tr class="row6">
		<td class="col0"> :cope(n) </td><td class="col1"> open a window with make output </td>
	</tr>
	<tr class="row7">
		<td class="col0"> :cn(ext) </td><td class="col1"> go to next error </td>
	</tr>
	<tr class="row8">
		<td class="col0"> :cp(revious) </td><td class="col1"> go to previous error </td>
	</tr>
	<tr class="row9">
		<td class="col0"> :cc </td><td class="col1"> go to current error </td>
	</tr>
	<tr class="row10">
		<td class="col0"> :ccl(ose) </td><td class="col1"> close the window with make output </td>
	</tr>
	<tr class="row11">
		<th class="col0 leftalign" colspan="2"> Motion  </th>
	</tr>
	<tr class="row12">
		<td class="col0"> Ctrl+O </td><td class="col1"> go to previous edition </td>
	</tr>
	<tr class="row13">
		<td class="col0"> Ctrl+I </td><td class="col1"> go to next edition </td>
	</tr>
</table>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Edit-Compile-Execute Cycle" [1824-2296] -->
<h2><a name="how_to_use_visual_bell_instead_of_beeping" id="how_to_use_visual_bell_instead_of_beeping">How to use visual bell instead of beeping</a></h2>
<div class="level2">
<pre class="code vim"><span class="sy0">:</span>set visualbell</pre>
<div class="tags"><span>
	<a href="/~kssilveira/site/doku.php?id=tag:programming&amp;do=showtag&amp;tag=tag%3Aprogramming" class="wikilink1" title="tag:programming" rel="tag">programming</a>
</span></div>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to use visual bell instead of beeping" [2297-] -->